//***********************************************************************
//
//  DlgDemo4.h
//
//***********************************************************************

#include "cregbinding.h"

class CMyApp : public CWinApp
{
public:
    virtual BOOL InitInstance ();
};

class CMainWindow : public CFrameWnd
{
private:
    int m_nFillType;
    int m_nFillColor;
    CString m_text;
    int m_nHeight;
    BOOL m_bBold;
    BOOL m_bItalic;

    // Binding Object 1
    CRegBinding rb;

    void DoSolidFill (CDC*, CRect*);
    void DoGradientFill (CDC*, CRect*);
    void DoDrawText (CDC*, CRect*);

public:
    CMainWindow ();

protected:
    afx_msg BOOL OnEraseBkgnd (CDC*);
    afx_msg void OnPaint ();
    afx_msg void OnOptionsSettings ();
    afx_msg void OnOptionsExit ();
    afx_msg void OnOptionsAbout ();

    DECLARE_MESSAGE_MAP ()
};

class CSettingsDialog : public CDialog
{
public:
    int m_nFillType;
    int m_nFillColor;
    CString m_text;
    int m_nHeight;
    BOOL m_bBold;
    BOOL m_bItalic;

    // Binding Object 2
    CRegBinding rb;

    CSettingsDialog (CWnd* pParentWnd = NULL) :
        CDialog (IDD_SETTINGSDLG, pParentWnd),
        rb("SettingsDialog") {}

protected:
    virtual void DoDataExchange (CDataExchange*);
    virtual BOOL OnInitDialog ();

    afx_msg void OnDefaults ();
    DECLARE_MESSAGE_MAP ()
};

class CAboutDialog : public CDialog
{
private:
    CRect m_rect;

    // Binding Object 3
    CRegBinding rb;

public:
    CAboutDialog (CWnd* pParentWnd = NULL) :
        CDialog (IDD_ABOUTDLG, pParentWnd),
        rb("AboutDialog") {}

    virtual BOOL OnInitDialog ();

protected:
    afx_msg void OnPaint ();
    DECLARE_MESSAGE_MAP ()
};
